//+------------------------------------------------------------------+
//|                                             Opening_Range_HT.mq4 |
//|                                      Copyright  2008, Kris Pivo |
//|                                           kris.pivo[at]gmail.com |
//| Opening Range Targets                              12 April 2008 |
//+------------------------------------------------------------------+
#property copyright " Kris"
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DarkGreen   // Opening Range Hi +15
#property indicator_color2 Green       // Opening Range Hi +10
#property indicator_color3 LimeGreen   // Opening Range Hi +05
#property indicator_color4 Red         // Opening Range Lo -05
#property indicator_color5 Crimson     // Opening Range Lo -10
#property indicator_color6 Maroon      // Opening Range Lo -15

extern int Entry_Levels = 2; 
extern int Target_PIPs  = 5; 

//---- buffers
double H15[];      // Opening Range Hi +15
double H10[];      // Opening Range Hi +10
double H05[];      // Opening Range Hi +05
double L05[];      // Opening Range Lo -05
double L10[];      // Opening Range Lo -10
double L15[];      // Opening Range Lo -15

//+------------------------------------------------------------------+
int init() {
	//---- indicators
	SetIndexBuffer(0,H15);
	SetIndexStyle( 0,DRAW_LINE,STYLE_DOT);
	SetIndexBuffer(1,H10);
	SetIndexStyle( 1,DRAW_LINE,STYLE_DOT);
	SetIndexBuffer(2,H05);
	SetIndexStyle( 2,DRAW_LINE,STYLE_DOT);
	SetIndexBuffer(3,L05);
	SetIndexStyle( 3,DRAW_LINE,STYLE_DOT);
	SetIndexBuffer(4,L10);
	SetIndexStyle( 4,DRAW_LINE,STYLE_DOT);
	SetIndexBuffer(5,L15);
	SetIndexStyle( 5,DRAW_LINE,STYLE_DOT);

	string short_name = "Opening Range Targets";
	IndicatorShortName(short_name);
	return(0);
}
//+------------------------------------------------------------------+
int deinit() {
	ObjectDelete("OR +15");
	ObjectDelete("OR +10");
	ObjectDelete("OR +05");
	ObjectDelete("OR -05");
	ObjectDelete("OR -10");
	ObjectDelete("OR -15");
	Comment("");
	return(0); }
//+------------------------------------------------------------------+

double prevL=0, prevH=0, prevC=0, prevO=0;
double ORHS, ORHi, ORLo, ORLS;
double ORH15, ORH10, ORH05, ORL05, ORL10, ORL15;

int thisHour = -1;

int start() {
	if (Period() > 60) return(0);		//Chart cannot be higher than H1
	
	int counted_bars=IndicatorCounted();
	if (counted_bars >0) counted_bars--;
	int limit=Bars-counted_bars;

	int period = MathCeil(60 / Period());

	for (int i = limit-1; i>=0; i--)
      {
      if (i + period < Bars && TimeMinute(iTime(NULL,0,i)) == 0 && thisHour != TimeHour(iTime(NULL,0,i)) ) {
			thisHour = TimeHour(iTime(NULL,0,i));
			prevH = High[Highest(NULL, 0, MODE_HIGH, period, i+1)];
			prevL = Low [Lowest (NULL, 0, MODE_LOW,  period, i+1)];
			prevC = Close[i+1];

         ORHi = High[i];
         ORLo = Low[i];
         ORHS = ORHi + Entry_Levels*Point;
         ORLS = ORLo - Entry_Levels*Point;
         
         ORH15 = ORHS + (Target_PIPs*Point)*3;
         ORH10 = ORHS + (Target_PIPs*Point)*2;
         ORH05 = ORHS + (Target_PIPs*Point)*1;
         ORL05 = ORLS - (Target_PIPs*Point)*1;
         ORL10 = ORLS - (Target_PIPs*Point)*2;
         ORL15 = ORLS - (Target_PIPs*Point)*3;
      }
		if (ORLo > 0)
		   {
         H15[i] = ORH15;
			H10[i] = ORH10;
			H05[i] = ORH05;
			L05[i] = ORL05;
			L10[i] = ORL10;
			L15[i] = ORL15;
		   }
	}
	return(0);}
//+------------------------------------------------------------------------------------+
//|                                 * * * THE END * * *                                |
//+------------------------------------------------------------------------------------+

